//--------------------------------------------------------------------------
/***********************************************************************
 *       (   ltr114
     )
  */
#include <vcl.h>
#pragma hdrstop

#include "LTR114_ProcessThread.h"
#include <stdio.h>
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall ltr114_ProcessThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------


// -      
__fastcall ltr114_ProcessThread::ltr114_ProcessThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
        this->crit_sect = new TCriticalSection();
        SetLtrStatus(LTR114THREAD_STATUS_WAIT);
}

//  /    
//   
//     
void ltr114_ProcessThread::SetLtrStatus(int Status)
{
    crit_sect->Enter();
    status = Status;
    crit_sect->Leave();
}

int ltr114_ProcessThread::GetLtrStatus()
{
    int res;
    crit_sect->Enter();
    res = status;
    crit_sect->Leave();
    return res;
}

//     
//   Syncronize (      )
void __fastcall ltr114_ProcessThread::update_data()
{
    for (int i=0; i < pltr114->LChQnt; i++)
        EditResArr[i]->Text = FloatToStr(ddata[i]);
    if (((pltr114->SpecialFeatures & LTR114_FEATURES_THERM)!=0) &&
                (tcnt!=0))
    {
        this->ThermEdit->Text = FloatToStr(tdata[0]);
    }
}

//     -    
//---------------------------------------------------------------------------
void __fastcall ltr114_ProcessThread::Execute()
{
    int res, size;
    SetLtrStatus(LTR114THREAD_STATUS_RUN);
    res = LTR114_Calibrate(pltr114);
    if (res == LTR_OK)
        LTR114_Start(pltr114);
    if (res == LTR_OK)
    {

        while ((GetLtrStatus() == LTR114THREAD_STATUS_RUN) &&(res==LTR_OK))
        {
            DWORD data[MAX_READ_SIZE];
            DWORD time[MAX_READ_SIZE];

            //   
            //   -        
            //  -      hltr114.FrameLength
            size = (int)(((double)LTR114_CLOCK)*1000/(LTR114_ADC_DIVIDER*pltr114->FreqDivider*pltr114->FrameLength));
            if (size < 1)
                size = 1;
            size *= pltr114->FrameLength;

            res = LTR114_Recv(pltr114, data, time, size, 2000);
            if (res > 0)
            {
                 size = res;
                //   -    LTR114_ProcessDataTherm
                //: LTR114_ProcessDataTherm        
                if ((pltr114->SpecialFeatures & LTR114_FEATURES_THERM) != 0)
                    res = LTR114_ProcessDataTherm(pltr114, data, ddata, tdata, &size, &tcnt, ltr_correction_mode, LTR114_PROCF_VALUE);     // 
                else
                    res = LTR114_ProcessData(pltr114, data, ddata, &size, ltr_correction_mode, LTR114_PROCF_VALUE);
                dcnt = size;
                Synchronize(update_data);
            }
        }  //while
       res = LTR114_Stop(pltr114);
    }  //if res=LTR_OK
    LTR114_Close(pltr114);

    if (res!=LTR_OK)
    {
        Application->MessageBox(LTR114_GetErrorString(res), "LTR114 Error");
        SetLtrStatus(LTR114THREAD_STATUS_ERROR);
    }
    else
        SetLtrStatus(LTR114THREAD_STATUS_STOPPED);

    // LTR114THREAD_STATUS_STOPPED  LTR114THREAD_STATUS_ERROR   
    //    OnTerminate

}
//---------------------------------------------------------------------------
